(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@angular/core'), require('nu-lazy')) :
    typeof define === 'function' && define.amd ? define('g2-angular', ['exports', '@angular/common', '@angular/core', 'nu-lazy'], factory) :
    (factory((global['g2-angular'] = {}),global.ng.common,global.ng.core,global.nu.lazy));
}(this, (function (exports,common,core,nuLazy) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var G2ChartConfig = /** @class */ (function () {
        function G2ChartConfig() {
        }
        return G2ChartConfig;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var G2ChartComponent = /** @class */ (function () {
        function G2ChartComponent(el, config, lazySrv) {
            this.el = el;
            this.config = config;
            this.lazySrv = lazySrv;
            this.initFlag = false;
            this.ready = new core.EventEmitter();
            this.destroy = new core.EventEmitter();
        }
        /**
         * @return {?}
         */
        G2ChartComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                // 构建一个虚拟id
                this.id = 'angular-g2-' + ++G2ChartComponent.idPool;
                this.el.nativeElement.id = this.id;
                this.initFlag = true;
                // 已经存在对象无须进入懒加载模式
                if (window.G2) {
                    this.init();
                    return;
                }
                this.lazySrv.load(this.config.js).then(function () { return _this.init(); });
            };
        /**
         * @param {?} changes
         * @return {?}
         */
        G2ChartComponent.prototype.ngOnChanges = /**
         * @param {?} changes
         * @return {?}
         */
            function (changes) {
                if ('options' in changes)
                    this.init();
            };
        /**
         * @private
         * @param {?=} options
         * @return {?}
         */
        G2ChartComponent.prototype.init = /**
         * @private
         * @param {?=} options
         * @return {?}
         */
            function (options) {
                if (!this.initFlag)
                    return;
                if (this.instance) {
                    this._destroy(false);
                }
                // 强制设置container为null，并使用 `id` 初始化
                this.instance = new window.G2.Chart(Object.assign({}, this.options, {
                    id: this.id,
                    container: null,
                }));
                this.ready.emit(this.instance);
            };
        /**
         * @private
         * @param {?=} needNotify
         * @return {?}
         */
        G2ChartComponent.prototype._destroy = /**
         * @private
         * @param {?=} needNotify
         * @return {?}
         */
            function (needNotify) {
                if (needNotify === void 0) {
                    needNotify = false;
                }
                if (this.instance) {
                    this.instance.destroy();
                    this.instance = null;
                }
                if (needNotify)
                    this.destroy.emit();
            };
        Object.defineProperty(G2ChartComponent.prototype, "Instance", {
            /**
             * 获取Chart实例
             */
            get: /**
             * 获取Chart实例
             * @return {?}
             */ function () {
                return this.instance;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        G2ChartComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                this._destroy(true);
            };
        G2ChartComponent.idPool = 0;
        G2ChartComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'g2-chart',
                        template: "",
                        encapsulation: core.ViewEncapsulation.None,
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        styles: ["g2-chart { display: block; } "]
                    }] }
        ];
        /** @nocollapse */
        G2ChartComponent.ctorParameters = function () {
            return [
                { type: core.ElementRef },
                { type: G2ChartConfig },
                { type: nuLazy.LazyService }
            ];
        };
        G2ChartComponent.propDecorators = {
            options: [{ type: core.Input }],
            ready: [{ type: core.Output }],
            destroy: [{ type: core.Output }]
        };
        return G2ChartComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var G2ChartModule = /** @class */ (function () {
        function G2ChartModule() {
        }
        /**
         * @param {?=} config
         * @return {?}
         */
        G2ChartModule.forRoot = /**
         * @param {?=} config
         * @return {?}
         */
            function (config) {
                return {
                    ngModule: G2ChartModule,
                    providers: [{ provide: G2ChartConfig, useValue: config }],
                };
            };
        G2ChartModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule],
                        declarations: [G2ChartComponent],
                        exports: [G2ChartComponent],
                    },] }
        ];
        return G2ChartModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.G2ChartModule = G2ChartModule;
    exports.ɵa = G2ChartComponent;
    exports.ɵb = G2ChartConfig;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=g2-angular.umd.js.map