import { CommonModule } from '@angular/common';
import { Component, Input, ElementRef, Output, EventEmitter, ChangeDetectionStrategy, ViewEncapsulation, NgModule } from '@angular/core';
import { LazyService } from 'nu-lazy';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class G2ChartConfig {
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class G2ChartComponent {
    /**
     * @param {?} el
     * @param {?} config
     * @param {?} lazySrv
     */
    constructor(el, config, lazySrv) {
        this.el = el;
        this.config = config;
        this.lazySrv = lazySrv;
        this.initFlag = false;
        this.ready = new EventEmitter();
        this.destroy = new EventEmitter();
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        // 构建一个虚拟id
        this.id = 'angular-g2-' + ++G2ChartComponent.idPool;
        this.el.nativeElement.id = this.id;
        this.initFlag = true;
        // 已经存在对象无须进入懒加载模式
        if (window.G2) {
            this.init();
            return;
        }
        this.lazySrv.load(this.config.js).then(() => this.init());
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    ngOnChanges(changes) {
        if ('options' in changes)
            this.init();
    }
    /**
     * @private
     * @param {?=} options
     * @return {?}
     */
    init(options) {
        if (!this.initFlag)
            return;
        if (this.instance) {
            this._destroy(false);
        }
        // 强制设置container为null，并使用 `id` 初始化
        this.instance = new window.G2.Chart(Object.assign({}, this.options, {
            id: this.id,
            container: null,
        }));
        this.ready.emit(this.instance);
    }
    /**
     * @private
     * @param {?=} needNotify
     * @return {?}
     */
    _destroy(needNotify = false) {
        if (this.instance) {
            this.instance.destroy();
            this.instance = null;
        }
        if (needNotify)
            this.destroy.emit();
    }
    /**
     * 获取Chart实例
     * @return {?}
     */
    get Instance() {
        return this.instance;
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        this._destroy(true);
    }
}
G2ChartComponent.idPool = 0;
G2ChartComponent.decorators = [
    { type: Component, args: [{
                selector: 'g2-chart',
                template: ``,
                encapsulation: ViewEncapsulation.None,
                changeDetection: ChangeDetectionStrategy.OnPush,
                styles: [`g2-chart { display: block; } `]
            }] }
];
/** @nocollapse */
G2ChartComponent.ctorParameters = () => [
    { type: ElementRef },
    { type: G2ChartConfig },
    { type: LazyService }
];
G2ChartComponent.propDecorators = {
    options: [{ type: Input }],
    ready: [{ type: Output }],
    destroy: [{ type: Output }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class G2ChartModule {
    /**
     * @param {?=} config
     * @return {?}
     */
    static forRoot(config) {
        return {
            ngModule: G2ChartModule,
            providers: [{ provide: G2ChartConfig, useValue: config }],
        };
    }
}
G2ChartModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule],
                declarations: [G2ChartComponent],
                exports: [G2ChartComponent],
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { G2ChartModule, G2ChartComponent as ɵa, G2ChartConfig as ɵb };

//# sourceMappingURL=g2-angular.js.map